unit frmmain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ExtCtrls;

type

  { TMainForm }

  TMainForm = class(TForm)
    BEncrypt: TButton;
    CBCheck: TCheckBox;
    EText: TLabeledEdit;
    EKey: TLabeledEdit;
    MEncrypted: TMemo;
    procedure BEncryptClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  MainForm: TMainForm;

implementation

uses blowfish, base64;

{ TMainForm }

Function DoEncrypt(Const AText, AKey : String) : String;
Var
  Src,Dest : TStringStream;
  Enc : TBlowFishEncryptStream;
  B : TBase64EncodingStream;
  K : TBlowFishKey;
  KL : Integer;
  T : String;

begin
  B:=Nil;
  T:=AKey;
  KL:=Length(T);
  If KL>56 then
    KL:=56;
  Move(T[1],K,KL);
  Dest:=TStringStream.Create('');
  try
    B:=TBase64EncodingStream.Create(Dest);
    try
      Enc:=TBlowFishEncryptStream.Create(K,KL,B);
      try
        Enc.Write(AText[1],Length(AText));
      finally
        Enc.Free;
      end;
    finally
      B.Free;
    end;
    Result:=Dest.DataString;
  finally
    Dest.Free;
  end;
end;

Function DoDecrypt(Const AText, AKey : String) : String;
Var
  Src,Dest : TStringStream;
  Decoder : TBlowFishDecryptStream;
  B : TBase64DecodingStream;
  K : TBlowFishKey;
  KL : Integer;
  T : String;
  Buf : Array[1..1024] of byte;
  Count : Integer;

begin
  B:=Nil;
  T:=AKey;
  KL:=Length(T);
  If KL>56 then
    KL:=56;
  Move(T[1],K,KL);
  Src:=TStringStream.Create(AText);
  try
    Dest:=TStringStream.Create('');
    try
      B:=TBase64DecodingStream.Create(Src,bdmStrict);
      try
        Decoder:=TBlowFishDecryptStream.Create(K,KL,B);
        try
          Repeat
            Count:=Decoder.Read(Buf,SizeOf(Buf));
            If Count>0 then
              Dest.WriteBuffer(Buf,Count);
          Until Count<SizeOf(Buf);
        finally
          Decoder.Free;
        end;
      finally
        B.Free;
      end;
      Result:=Trim(Dest.DataString);
    finally
      Dest.Free;
    end;
  finally
    Src.Free;
  end;
end;

procedure TMainForm.BEncryptClick(Sender: TObject);

Var
  O,K,S,R,Msg : String;

begin
  O:=EText.Text;
  K:=EKey.Text;
  S:=DoEncrypt(O,K);
  MEncrypted.Lines.text:=S;
  If CBCheck.Checked then
    begin
    R:=DoDecrypt(S,K);
    If (O<>R) then
      Msg:=Format('Decryption failed: "%s" <> "%s"',[O,R])
    else
      Msg:='Decryption succesful !';
    ShowMessage(Msg);
    end;
end;


initialization
  {$I frmmain.lrs}

end.

